const text_screen = $0400

start:
    ldd #$0000      ; load the value 0                  | 
    std var         ; store the value 0 in var          | var = 0
loop:                                                   | do {
    ldd var         ; load the value of var             | 
    pshs d          ; save d                            | 
    jsr PrintDigit  ; print the value of var            | print(var)
    puls d          ; remove d from the stack           |

    ldd var         ; load the value of var             |
    addd #$0001     ; add 1 to the value of var,        | var += 1
    std var         ; store the new value of var        |
    
    cmpd #$000A     ; compare with the value 9 + 1 = A  | 
    bne loop        ; if not equal, go to loop          | } while (var != 10)
    rts             ; return from subroutine            | return
var:
    .word 0         ; reserve 2 bytes for the variable

PrintDigit:         ; This function prints the value in the stack
                    ; at the address of the user stack pointer u + 4, 
                    ; pshs <a>: push any register <a> to the stack 
    pshs u          ; save u, s = s - 2                 | 
    leau ,s         ; u = s                             | PrintDigit(int x) {
    
    ldd $04,u       ; d = mem[u + 4]                    | d = x
    addd #'0'       ; d = d + '0'                       | d += '0'
    stb text_screen ; mem[text_screen] = b              | print(d)

    leas ,u         ; s = u                             | }
    puls u          ; load u
    rts