const text_screen = $0400

Start:  
    ldd #$0007          ; d = 7
    pshs d              ; save d
    lbsr Fibonacci      ; call Fibonacci
    puls d              ; load d
    rts

Fibonacci:              ; fib requires a parameter in a
    pshs u              ; mem[--s] = u
    leau ,s             ; u = s

    ldd #0              ; d = 0
    pshs d              ; mem[--s] = d          def a = 0
    ldd #1              ; d = 1
    pshs d              ; mem[--s] = d          def b = 1
fib_loop:
    ldd $04, u          ; d = mem[u + 4]
    cmpd #0             ; if d = 0              if n = 0
    beq fib_done        ; return 0
    subd #1             ; d = d - 1 
    std $04,u           ; mem[u + 4] = d        n = n - 1

    ldd $02,s           ; d = mem[s + 2]
    pshs d              ; mem[--s] = d          
    lbsr PrintDigit     ; call PrintDigit
    puls d              ; d = mem[s++]

    ldd ,s              ; d = mem[s]
    addd $02,s          ; d = mem[s + 2]        a = mem[s] + mem[s + 2]
    ldx ,s              ; x = mem[s]            x = mem[s]
    std ,s              ; mem[s] = d            mem[s] = a
    stx $02,s           ; mem[s + 2] = x        mem[s + 2] = x

    bra fib_loop        ; goto fib_loop
fib_done:
    leas ,u             ; s = u
    puls u              ; u = mem[s++]
    rts                 ; return

PrintDigit:
    pshs u              ; save u
    leau ,s             ; u = s
    
    ldd $04,u           ; d = mem[u + 4]
    addd #'0'           ; d = d + '0'
    stb text_screen     ; mem[text_screen] = b

    leas ,u             ; s = u
    puls u              ; load u
    rts